unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Registry, StdCtrls, ShellAPI;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure ButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    Reg : TRegistry;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{* The GUID was generated using the M$ guidgen.exe. This is my unique ID
 * All the program does is add some new values to the IE reg settings.
 *
 * "Default Visible" :
 *                Yes to have the button on the menu as default and set to No
 *                if you dont want it as default.
 *
 * "ButtonText" :
 *               This is the text in the label when you put your mouse over the button
 *
 * "HotIcon":
 *           This value holds the directory that the .ico's are stored in
 *
 * "Icon":
 *        is the actuall path and file name of the icon
 *
 * "CLSID":
 *          This is to say it is a button and the value for that is:
 *          {1FBA04EE-3024-11D2-8F1F-0000F87ABD16}
{*
 * "Exec"
 *        is the path of the exe you want to execute when the button is clicked
 *
 *
 * If the button doesnt appear on your menu download guidgen.exe from M$ and generate a
 * new GUID.
 *
 * vote ma code}


procedure TForm1.ButtonClick(Sender: TObject);
var
 GUID : string;
 Reg : TRegistry;
 Del : string;
begin
  GUID := '{986CDFC3-0AFC-49ac-942D-2E9CAEE079FC}';  // my ID. gotta use guidgen.exe

  Reg := TRegistry.create;
  Reg.RootKey := HKEY_LOCAL_MACHINE;
  Reg.OpenKey('SOFTWARE\Microsoft\Internet Explorer\Extensions\', true);

    if Sender = Button1 then
      begin
        if Reg.CreateKey(GUID)then
        begin
          Reg.OpenKey(GUID, true);
          Reg.WriteString('Default Visible', 'Yes');  { make the button default on the toolbar}
          Reg.WriteString('ButtonText', '0xSoftware');
          Reg.WriteString('HotIcon', ExtractFilePath(Application.ExeName)+'Icon.ico');
          Reg.WriteString('Icon', ExtractFilePath(Application.ExeName)+'Icon.ico');
          Reg.WriteString('CLSID', '{1FBA04EE-3024-11D2-8F1F-0000F87ABD16}');
          Reg.WriteString('Exec', Application.ExeName);
          showmessage('Button added to explorer.');
          ShellExecute(Handle, 'open', 'IEXPLORE.exe', nil, 0, SW_SHOW);
        end;
      end
    else
      begin
        Reg.DeleteKey(GUID);
        ShowMessage('Button removed');
        ShellExecute(Handle, 'open', 'IEXPLORE.exe', nil, 0, SW_SHOW);
      end;
  Reg.CloseKey;
  Reg.Free;
end;

end.
